"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var form_1 = require("./form");
function CustomSelect(_a) {
    var children = _a.children, options = _a.options, name = _a.name, value = _a.value, onChange = _a.onChange, onBlur = _a.onBlur, props = __rest(_a, ["children", "options", "name", "value", "onChange", "onBlur"]);
    var selectWithOptions = React.Children.map(children, function (child) {
        if (React.isValidElement(child)) {
            return React.cloneElement(child, __assign({ name: name, value: value, onChange: onChange, onBlur: onBlur }, props), options.map(function (option) { return (jsx_runtime_1.jsx("option", __assign({ value: option.value }, props, { children: option.value }), option.id)); }));
        }
        return child;
    });
    return jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: selectWithOptions }, void 0);
}
function PropDriller(_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    var childrenWithProps = React.Children.map(children, function (child) {
        if (React.isValidElement(child)) {
            return React.cloneElement(child, props);
        }
        return child;
    });
    return jsx_runtime_1.jsx(jsx_runtime_1.Fragment, { children: childrenWithProps }, void 0);
}
function Field(_a) {
    var name = _a.name, element = _a.element, props = __rest(_a, ["name", "element"]);
    var _b = form_1.useFormContext(), values = _b.values, handleChange = _b.handleChange, handleBlur = _b.handleBlur;
    var value = values[name];
    switch (props.type) {
        case "select":
            if (element) {
                return (jsx_runtime_1.jsx(CustomSelect, __assign({ name: name, onChange: handleChange, onBlur: handleBlur, value: value }, props, { children: element }), void 0));
            }
            else {
                return (jsx_runtime_1.jsx("select", __assign({ name: name, value: value, onBlur: handleBlur, onChange: handleChange }, { children: props.options.map(function (option) { return (jsx_runtime_1.jsx("option", __assign({ value: option.value }, props, { children: option.value }), option.id)); }) }), void 0));
            }
        case "textarea":
            if (element) {
                return (jsx_runtime_1.jsx(PropDriller, __assign({ name: name, onChange: handleChange, onBlur: handleBlur, value: value }, props, { children: element }), void 0));
            }
            else {
                return (jsx_runtime_1.jsx("textarea", __assign({ name: name, value: value }, props, { onBlur: handleBlur, onChange: handleChange }), void 0));
            }
        default:
            if (element) {
                return (jsx_runtime_1.jsx(PropDriller, __assign({ name: name, value: value, onChange: handleChange, onBlur: handleBlur }, props, { children: element }), void 0));
            }
            else {
                return (jsx_runtime_1.jsx("input", __assign({ name: name, value: value, onChange: handleChange, onBlur: handleBlur }, props), void 0));
            }
    }
}
exports.default = Field;
//# sourceMappingURL=field.js.map