"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFormContext = exports.Form = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
function validateErrors(_a) {
    var _b;
    var errors = _a.errors, setErrors = _a.setErrors, targetName = _a.targetName, newValue = _a.newValue, context = _a.context;
    var error = "";
    if (context) {
        // Looping through the context values
        for (var _i = 0, _c = Object.entries(context); _i < _c.length; _i++) {
            var _d = _c[_i], key = _d[0], requirements = _d[1];
            if (key !== targetName)
                continue;
            setErrors(__assign(__assign({}, errors), (_b = {}, _b[key] = "", _b)));
            if (typeof requirements === "object" && requirements !== null) {
                // Loop through each given validation type
                for (var _e = 0, _f = Object.entries(requirements); _e < _f.length; _e++) {
                    var _g = _f[_e], validationType = _g[0], givenObject = _g[1];
                    // Is the field required
                    // Checking whether the field has an object of validationOptions
                    // If it is, does it have a value
                    if (validationType === "required" &&
                        typeof givenObject === "object" &&
                        givenObject !== null &&
                        !newValue) {
                        var isRequired = false;
                        var errorMessage = "";
                        for (var _h = 0, _j = Object.entries(givenObject); _h < _j.length; _h++) {
                            var _k = _j[_h], optionKey = _k[0], optionValue = _k[1];
                            if (optionKey === "is" && optionValue === true) {
                                isRequired = true;
                            }
                            if (optionKey === "errorMessage" &&
                                typeof optionValue === "string") {
                                errorMessage = optionValue;
                            }
                        }
                        // If there is an error we put the message on top of it, otherwise we just use this one
                        if (isRequired && errorMessage) {
                            error = error ? error + (" " + errorMessage) : errorMessage;
                        }
                        else if (isRequired) {
                            error = error
                                ? error + " This field is required."
                                : "This field is required.";
                        }
                    }
                    // Max charcters
                    if (validationType === "maxCharacters" &&
                        typeof givenObject === "object" &&
                        givenObject !== null) {
                        var isError = false;
                        var maxCharactors = undefined;
                        var errorMessage = "";
                        // Looping the options of validation
                        for (var _l = 0, _m = Object.entries(givenObject); _l < _m.length; _l++) {
                            var _o = _m[_l], optionKey = _o[0], optionValue = _o[1];
                            // Each item in this loop is a validation option
                            if (optionKey === "is" && typeof optionValue === "number") {
                                // The new value in the form is too long
                                if (String(newValue).length > optionValue) {
                                    isError = true;
                                    maxCharactors = optionValue;
                                }
                            }
                            else if (optionKey === "errorMessage" &&
                                typeof optionValue === "string" &&
                                isError) {
                                errorMessage = optionValue;
                            }
                        }
                        // If an error was present we update the error string
                        if (isError && maxCharactors && errorMessage) {
                            error = error ? error + (" " + errorMessage) : errorMessage;
                        }
                        else if (isError) {
                            error = error
                                ? error +
                                    (" This field cannot be more than " + maxCharactors + " characters long.")
                                : "This field cannot be more than " + maxCharactors + " characters long.";
                        }
                    }
                    // Min charcters
                    if (validationType === "minCharacters" &&
                        typeof givenObject === "object" &&
                        givenObject !== null) {
                        var isError = false;
                        var minCharactors = undefined;
                        var errorMessage = "";
                        // Looping the options of validation
                        for (var _p = 0, _q = Object.entries(givenObject); _p < _q.length; _p++) {
                            var _r = _q[_p], optionKey = _r[0], optionValue = _r[1];
                            // Each item in this loop is a validation option
                            if (optionKey === "is" && typeof optionValue === "number") {
                                // The new value in the form is not long enough
                                if (String(newValue).length < optionValue) {
                                    isError = true;
                                    minCharactors = optionValue;
                                }
                            }
                            else if (optionKey === "errorMessage" &&
                                typeof optionValue === "string" &&
                                isError) {
                                errorMessage = optionValue;
                            }
                        }
                        // If an error happened we update the error string
                        if (isError && minCharactors && errorMessage) {
                            error = error ? error + (" " + errorMessage) : errorMessage;
                        }
                        else if (isError) {
                            error = error
                                ? error +
                                    (" This field cannot be less than " + minCharactors + " characters.")
                                : "This field cannot be less than " + minCharactors + " characters.";
                        }
                    }
                    // Email validation
                    if (validationType === "email" &&
                        typeof givenObject === "object" &&
                        givenObject !== null) {
                        var isError = false;
                        var errorMessage = "";
                        // Each item in this loop is a validation option
                        for (var _s = 0, _t = Object.entries(givenObject); _s < _t.length; _s++) {
                            var _u = _t[_s], optionKey = _u[0], optionValue = _u[1];
                            if (optionKey === "is" && typeof optionValue === "boolean") {
                                if (!/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,}$/i.test(String(newValue))) {
                                    // If the email is invalid we set isError to true
                                    isError = true;
                                }
                                // We are either using the given errorMessage or our own
                            }
                            else if (optionKey === "errorMessage" &&
                                typeof optionValue === "string" &&
                                isError) {
                                errorMessage = optionValue;
                            }
                        }
                        // If an error happend we update the error string
                        if (isError && errorMessage) {
                            error = error ? error + (" " + errorMessage) : errorMessage;
                        }
                        else if (isError) {
                            error = error
                                ? error + " Invalid email address."
                                : "Invalid email address.";
                        }
                    }
                    // Has to include validation
                    if (validationType === "hasToInclude" &&
                        typeof givenObject === "object" &&
                        givenObject !== null) {
                        var isError = false;
                        var errorMessage = "";
                        var whatToContain = "";
                        for (var _v = 0, _w = Object.entries(givenObject); _v < _w.length; _v++) {
                            var _x = _w[_v], optionKey = _x[0], optionValue = _x[1];
                            if (optionKey === "is" && typeof optionValue === "string") {
                                if (!String(newValue).includes(optionValue)) {
                                    isError = true;
                                    whatToContain = optionValue;
                                }
                            }
                            if (optionKey === "errorMessage" &&
                                typeof optionValue === "string" &&
                                isError) {
                                errorMessage = optionValue;
                            }
                        }
                        // If an error happend we update the error string
                        if (isError && errorMessage) {
                            error = error ? error + (" " + errorMessage) : errorMessage;
                        }
                        else if (isError) {
                            error = error
                                ? error + (" This field has to contain: " + whatToContain + ".")
                                : "This field has to contain: " + whatToContain + ".";
                        }
                    }
                }
            }
        }
    }
    return error;
}
var FormContext = React.createContext(null);
function useFormContext() {
    var context = React.useContext(FormContext);
    if (!context) {
        throw new Error("Form helpers were used outside of a the Form component");
    }
    return context;
}
exports.useFormContext = useFormContext;
var ValidationContext = React.createContext(undefined);
var useValidationContext = function () { return React.useContext(ValidationContext); };
function FormProvider(_a) {
    var formHelpers = _a.formHelpers, onSubmit = _a.onSubmit, children = _a.children, props = __rest(_a, ["formHelpers", "onSubmit", "children"]);
    var context = useValidationContext();
    var setErrors = formHelpers.setErrors, errors = formHelpers.errors, setValues = formHelpers.setValues, values = formHelpers.values, touchAllFields = formHelpers.touchAllFields;
    if (context) {
        formHelpers = __assign(__assign({}, formHelpers), { handleChange: function (e) {
                var _a, _b;
                var newValue;
                var targetName = e.target.name;
                if (e.target.type === "checkbox") {
                    newValue = e.target.checked;
                }
                else {
                    newValue = e.target.value;
                }
                setValues(__assign(__assign({}, values), (_a = {}, _a[targetName] = newValue, _a)));
                var newError = validateErrors({
                    errors: errors,
                    newValue: newValue,
                    setErrors: setErrors,
                    targetName: targetName,
                    context: context,
                });
                setErrors(__assign(__assign({}, errors), (_b = {}, _b[targetName] = newError, _b)));
            } });
    }
    function handleSubmit(e) {
        var _a;
        e.preventDefault();
        // I think submitting is kind of the same as touching all of the fields
        touchAllFields();
        // Validate errors before submit
        var newErrors = {};
        if (context) {
            for (var _i = 0, _b = Object.entries(values); _i < _b.length; _i++) {
                var _c = _b[_i], targetName = _c[0], value = _c[1];
                var newValue = value;
                if (!value) {
                    newValue = "";
                }
                /*
                  Because of the way state works, we have to create a new object with the errors
                  to be able to check if they exist in the forloop later
                */
                newErrors = __assign(__assign({}, newErrors), (_a = {}, _a[targetName] = validateErrors({
                    errors: errors,
                    setErrors: setErrors,
                    newValue: newValue,
                    targetName: targetName,
                    context: context,
                }), _a));
            }
            setErrors(newErrors);
        }
        // If an error is currently active, we don't run the submit
        for (var _d = 0, _e = Object.values(newErrors); _d < _e.length; _d++) {
            var value = _e[_d];
            if (value)
                return;
        }
        // Run the users onSubmit function
        onSubmit(e);
    }
    return (jsx_runtime_1.jsx(FormContext.Provider, __assign({ value: formHelpers }, { children: jsx_runtime_1.jsx("form", __assign({ onSubmit: handleSubmit }, props, { children: children }), void 0) }), void 0));
}
function Form(_a) {
    var formHelpers = _a.formHelpers, onSubmit = _a.onSubmit, validation = _a.validation, children = _a.children, props = __rest(_a, ["formHelpers", "onSubmit", "validation", "children"]);
    return (jsx_runtime_1.jsx(ValidationContext.Provider, __assign({ value: validation }, { children: jsx_runtime_1.jsx(FormProvider, __assign({ formHelpers: formHelpers, onSubmit: onSubmit }, props, { children: children }), void 0) }), void 0));
}
exports.Form = Form;
//# sourceMappingURL=form.js.map