import * as React from "react";
declare type CustomSelectProps = {
    children: React.ReactNode;
    options: Array<{
        id: number | string;
        value: string;
    }>;
    name: string;
    value: string;
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    onBlur: (e: React.FocusEvent<HTMLInputElement>) => void;
};
declare type PropDrillerProps = {
    children: React.ReactNode;
    name: string;
    value: string;
    onChange: unknown;
    onBlur: unknown;
};
declare type Select = {
    type: "select";
    name: string;
    id?: string;
    options: Array<{
        id: number | string;
        value: string;
    }>;
    element?: JSX.Element;
    className?: string;
    style?: React.CSSProperties;
};
declare type Textarea = {
    type: "textarea";
    name: string;
    id?: string;
    element?: JSX.Element;
    placeholder?: string;
    className?: string;
    style?: React.CSSProperties;
};
declare type Checkbox = {
    type: "checkbox";
    name: string;
    id?: string;
    element?: JSX.Element;
    className?: string;
    style?: React.CSSProperties;
};
declare type TextField = {
    type?: "text" | "email" | "password" | "number";
    name: string;
    id?: string;
    element?: JSX.Element;
    placeholder?: string;
    className?: string;
    style?: React.CSSProperties;
};
declare type Radio = {
    type: "radio";
    name: string;
    id?: string;
    value: string;
    element?: JSX.Element;
    className?: string;
    style?: React.CSSProperties;
};
declare type FieldProps = Checkbox | Radio | Select | Textarea | TextField;
export type { CustomSelectProps, PropDrillerProps, FieldProps };
//# sourceMappingURL=field.d.ts.map