"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var form_1 = require("./form");
function useField(fieldName) {
    var _a = form_1.useFormContext(), values = _a.values, handleChange = _a.handleChange, handleBlur = _a.handleBlur, errors = _a.errors, allTouched = _a.touched;
    var value = values[fieldName];
    var error = errors[fieldName];
    var touched = allTouched[fieldName];
    var field = {
        name: fieldName,
        value: value,
        onChange: handleChange,
        onBlur: handleBlur,
    };
    var info = {
        error: error,
        touched: touched,
    };
    return {
        field: field,
        info: info,
    };
}
exports.default = useField;
//# sourceMappingURL=use-field.js.map