import * as React from "react";
import type * as TForm from "./types";
declare function useFormAssist<TValues>(initialValues: TValues, validationOptions?: TForm.TValidation<TValues>): {
    formHelpers: {
        values: TValues;
        setValues: React.Dispatch<React.SetStateAction<TValues>>;
        errors: TForm.Errors<TValues>;
        setErrors: React.Dispatch<React.SetStateAction<TForm.Errors<TValues>>>;
        touched: TForm.Touched<TValues>;
        handleChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
        handleBlur: (e: React.FocusEvent<HTMLInputElement>) => void;
        resetForm: () => void;
        touchAllFields: () => void;
    };
    validation: TForm.TValidation<TValues>;
};
declare function useFormAssistStorage<TValues>(localStoageKey: string, initialValues: TValues, validationOptions?: TForm.TValidation<TValues>): {
    formHelpers: {
        values: TValues;
        setValues: React.Dispatch<React.SetStateAction<TValues>>;
        errors: TForm.Errors<TValues>;
        setErrors: React.Dispatch<React.SetStateAction<TForm.Errors<TValues>>>;
        touched: TForm.Touched<TValues>;
        handleChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
        handleBlur: (e: React.FocusEvent<HTMLInputElement>) => void;
        resetForm: () => void;
        touchAllFields: () => void;
        deleteStorage: () => void;
    };
    validation: TForm.TValidation<TValues>;
};
export { useFormAssist, useFormAssistStorage };
//# sourceMappingURL=use-form-assist.d.ts.map