"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useFormAssistStorage = exports.useFormAssist = void 0;
var React = __importStar(require("react"));
function useValidation(_formValues, validationOptions) {
    var validation = React.useState(validationOptions)[0];
    return validation;
}
function useForm(initialValues, values, setValues) {
    function setInitialErrors() {
        var _a;
        var errors = {};
        for (var _i = 0, _b = Object.keys(initialValues); _i < _b.length; _i++) {
            var key = _b[_i];
            errors = __assign(__assign({}, errors), (_a = {}, _a[key] = "", _a));
        }
        return errors;
    }
    function setInitialTouched(_a) {
        var _b;
        var isTouched = _a.isTouched;
        var touched = {};
        for (var _i = 0, _c = Object.keys(initialValues); _i < _c.length; _i++) {
            var key = _c[_i];
            touched = __assign(__assign({}, touched), (_b = {}, _b[key] = isTouched, _b));
        }
        return touched;
    }
    var _a = React.useState(function () {
        return setInitialErrors();
    }), errors = _a[0], setErrors = _a[1];
    var _b = React.useState(function () {
        return setInitialTouched({ isTouched: false });
    }), touched = _b[0], setTouched = _b[1];
    function handleChange(e) {
        var _a;
        var value;
        if (e.target.type === "checkbox") {
            value = e.target.checked;
        }
        else {
            value = e.target.value;
        }
        setValues(__assign(__assign({}, values), (_a = {}, _a[e.target.name] = value, _a)));
    }
    function handleBlur(e) {
        var _a;
        setTouched(__assign(__assign({}, touched), (_a = {}, _a[e.target.name] = true, _a)));
    }
    function resetForm() {
        setValues(initialValues);
        setErrors(setInitialErrors());
        setTouched(setInitialTouched({ isTouched: false }));
    }
    function touchAllFields() {
        setTouched(setInitialTouched({ isTouched: true }));
    }
    var formHelpers = {
        errors: errors,
        setErrors: setErrors,
        touched: touched,
        handleChange: handleChange,
        handleBlur: handleBlur,
        resetForm: resetForm,
        touchAllFields: touchAllFields,
    };
    return formHelpers;
}
// This hook will be used by the users, to call both the useForm and useValidaion hook togeher
function useFormAssist(initialValues, validationOptions) {
    if (validationOptions === void 0) { validationOptions = {}; }
    var _a = React.useState(initialValues), values = _a[0], setValues = _a[1];
    var _b = useForm(initialValues, values, setValues), errors = _b.errors, setErrors = _b.setErrors, touched = _b.touched, handleChange = _b.handleChange, handleBlur = _b.handleBlur, resetForm = _b.resetForm, touchAllFields = _b.touchAllFields;
    var validation = useValidation(initialValues, validationOptions);
    var formHelpers = {
        values: values,
        setValues: setValues,
        errors: errors,
        setErrors: setErrors,
        touched: touched,
        handleChange: handleChange,
        handleBlur: handleBlur,
        resetForm: resetForm,
        touchAllFields: touchAllFields,
    };
    return { formHelpers: formHelpers, validation: validation };
}
exports.useFormAssist = useFormAssist;
function useFormAssistStorage(localStoageKey, initialValues, validationOptions) {
    if (validationOptions === void 0) { validationOptions = {}; }
    var _a = React.useState(function () {
        return JSON.parse(window.localStorage.getItem(localStoageKey) ||
            JSON.stringify(initialValues));
    }), values = _a[0], setValues = _a[1];
    function deleteStorage() {
        window.localStorage.removeItem(localStoageKey);
    }
    React.useEffect(function () {
        // set local storage
        window.localStorage.setItem(localStoageKey, JSON.stringify(values));
    }, [values]);
    var _b = useForm(initialValues, values, setValues), errors = _b.errors, setErrors = _b.setErrors, touched = _b.touched, handleChange = _b.handleChange, handleBlur = _b.handleBlur, resetForm = _b.resetForm, touchAllFields = _b.touchAllFields;
    var validation = useValidation(initialValues, validationOptions);
    var formHelpers = {
        values: values,
        setValues: setValues,
        errors: errors,
        setErrors: setErrors,
        touched: touched,
        handleChange: handleChange,
        handleBlur: handleBlur,
        resetForm: resetForm,
        touchAllFields: touchAllFields,
        deleteStorage: deleteStorage,
    };
    return { formHelpers: formHelpers, validation: validation };
}
exports.useFormAssistStorage = useFormAssistStorage;
//# sourceMappingURL=use-form-assist.js.map